"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _execa = _interopRequireDefault(require("execa"));

var PackageManager =
/*#__PURE__*/
function () {
  function PackageManager() {
    (0, _classCallCheck2.default)(this, PackageManager);
  }

  (0, _createClass2.default)(PackageManager, [{
    key: "install",
    value: function () {
      var _install = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(packageManager, projectPath, packages) {
        var isDev,
            commands,
            _args = arguments;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                isDev = _args.length > 3 && _args[3] !== undefined ? _args[3] : false;
                _context.prev = 1;
                commands = (0, _toConsumableArray2.default)(packages);

                if (isDev) {
                  commands.unshift('-D');
                }

                _context.next = 6;
                return (0, _execa.default)(packageManager, ['add'].concat((0, _toConsumableArray2.default)(commands)), {
                  cwd: projectPath,
                  stdio: 'inherit'
                });

              case 6:
                _context.next = 11;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context["catch"](1);
                return _context.abrupt("return", Promise.reject(_context.t0));

              case 11:
                return _context.abrupt("return", Promise.resolve());

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[1, 8]]);
      }));

      function install(_x, _x2, _x3) {
        return _install.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: "generatePackageJson",
    value: function generatePackageJson(packageManager, name, description) {
      var packageJson = {
        name: name,
        main: 'index.js',
        version: '1.0.0',
        description: description,
        scripts: {
          'local': "".concat(packageManager, " run build && sls offline start"),
          'deploy:dev': "".concat(packageManager, " run build && serverless deploy --stage dev"),
          'confirm:production': 'cli-confirm \' Do you want to deploy production server? \'',
          'deploy:production': "".concat(packageManager, " run confirm:production && ").concat(packageManager, " run build && serverless deploy --stage production")
        },
        dependencies: {},
        devDependencies: {},
        keywords: []
      };
      return packageJson;
    }
  }]);
  return PackageManager;
}();

var packageManager = new PackageManager();
var _default = packageManager;
exports.default = _default;