"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FlowTypeChecker = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _interface = require("./interface");

var _execa = _interopRequireDefault(require("execa"));

var FlowTypeChecker =
/*#__PURE__*/
function () {
  function FlowTypeChecker() {
    (0, _classCallCheck2.default)(this, FlowTypeChecker);
  }

  (0, _createClass2.default)(FlowTypeChecker, [{
    key: "generateTemplatePath",
    value: function generateTemplatePath() {
      return 'template/flow/';
    }
  }, {
    key: "getInstallPackages",
    value: function getInstallPackages() {
      return ['flow-bin@^0.95.0', 'flow-typed@^2.0.0', '@babel/preset-flow'];
    }
  }, {
    key: "runExtraSettings",
    value: function () {
      var _runExtraSettings = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(projectPath) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _execa.default)('flow-typed', ['install', 'express@^4.0.0'], {
                  cwd: projectPath
                });

              case 2:
                return _context.abrupt("return");

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function runExtraSettings(_x) {
        return _runExtraSettings.apply(this, arguments);
      }

      return runExtraSettings;
    }()
  }, {
    key: "injectSettingsToEslintConfig",
    value: function injectSettingsToEslintConfig(config) {
      var newConfig = (0, _objectSpread2.default)({}, config, {
        parser: 'babel-eslint'
      });
      return newConfig;
    }
  }, {
    key: "getBuildScript",
    value: function getBuildScript() {
      return 'babel src/ -d lib/';
    }
  }]);
  return FlowTypeChecker;
}();

exports.FlowTypeChecker = FlowTypeChecker;